/**
 * Title:        <p>
 * Description:  <p>
 * Copyright:    Copyright (c) <p>
 * Company:      <p>
 * @author
 * @version 1.0
 */
package vishnu.testvis.visual;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import java.util.Date;

import javax.swing.JPanel;
import java.awt.*;
import javax.swing.border.*;
import java.awt.event.*;

public class PlainPanel extends JPanel
{
    Vishnu displayFrame;
    BorderLayout borderLayout1;
    Border border1;
    JScrollPane theScrollPane;
    JEditorPane theEditorPane;


  // This method returns an HTML table
    public String makeHTMLTable()
    {
        String [] descriptions = displayFrame.dataManager.getDescriptions();
        int [] docNums = displayFrame.dataManager.getDocs();
        // Set up an output stream we can print the table to.
        // This is easier than concatenating strings all the time.
        int number;
        if (docNums==null) number = 0;
        else number = docNums.length;

        StringWriter sout = new StringWriter();
        PrintWriter out = new PrintWriter(sout);

        // Print out the table
	Dimension d = displayFrame.getSize();
	int totalWidth = d.width-40;
	int textWidth = totalWidth - 100;
	
        out.println("<TABLE BORDER= 2 WIDTH=" + totalWidth + "><TR>");

        out.println("<TH WIDTH= 100>Document Number</TH>");
        out.println("<TH WIDTH = " + textWidth + ">Sample Text</TH></TR>");

        for(int i=0; i < docNums.length; i++)
        {
            out.print("<TR><TD><A HREF=\"");
            out.print(docNums[i]);
            out.print("\">");
            out.print(docNums[i]);
            out.print("</A></TD><TD>");
            out.print(descriptions [i]);
            out.println("</TD></TR>");
        }
        out.println("</TABLE>");
        out.close();

        // Get the string of HTML from the StringWriter and return it.
        return sout.toString();
    }

    public PlainPanel()
    {
        try
        {
            jbInit();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }


    public PlainPanel(Vishnu d)
    {
        displayFrame = d;
        try
        {
            jbInit();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }


// The sychronized qualifier is placed here because when two plain
// panels are created in different threads almost simulataniously
// we seem to get interference happening
    public synchronized void jbInit() throws Exception
    {
        borderLayout1 = new BorderLayout();
        theEditorPane = new JEditorPane();

        border1 = BorderFactory.createEmptyBorder(10,10,10,10);
        theEditorPane.setEditable(false);               // we're browsing not editing
        theEditorPane.setContentType("text/html");      // must specify HTML text
        theEditorPane.setText("<TABLE BORDER= 2 WIDTH=640><TR>"+
                                "<TH WIDTH= 100>Document Number</TH>" +
                                "<TH WIDTH = 520>Sample Text</TH></TR>" +
                                "</TABLE>");  // specify the text to display
        theEditorPane.setFont(new java.awt.Font("Monospaced", 0, 12));
    // Set up the JEditorPane to handle clicks on hyperlinks
        theEditorPane.addHyperlinkListener(new HyperlinkListener() {
                public void hyperlinkUpdate(HyperlinkEvent e)
                {
	            // Handle clicks; ignore mouseovers and other link-related events
	                if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED)
                    {
	            // Get the HREF of the link and display it.
                        String hpresult = e.getDescription();
                        int index = Integer.parseInt(hpresult);
                        if (index > 0)
                            displayFrame.dataManager.fetchDocNo(index);
	                }
                }
            });

        // Put the JEditorPane in a scrolling window and display it.

        this.setLayout(borderLayout1);
        this.setFont(new java.awt.Font("Monospaced", 0, 12));
        this.setBorder(border1);
        theScrollPane = new JScrollPane();
        //theScrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
        this.add(theScrollPane, BorderLayout.CENTER);
        theScrollPane.getViewport().add(theEditorPane, null);
        setSize(600, 400);
        setVisible(true);
    }

    public void update()
    {
       theEditorPane.setText(makeHTMLTable());
    }

    public void paint(Graphics g)
    {
	update();
    }


}
